//full list of elements on this widget
var elements = {};

//register new widget
function alteratorRegisterWidget(id,parent,widget)
{
	elements[id] = widget;
	elements[(parent=="")?"root":parent].add(widget);
	return widget;
}

//register new button
function alteratorRegisterButton(id,parent)
{
	var button = alteratorRegisterWidget(id,parent,new QxButton);
	//also setup callbacks here
	button.setAttr = function (name,value)
	{
		switch (name)
		{
			case "text":
				this.setText(value);
				break;
			default:
				alert("Unknown attribute " + name + "for button widget");
				break;
		}
	}
}


function alteratorRegisterEdit(id,parent)
{
	var edit = alteratorRegisterWidget(id,parent, new QxTextField);
	//also setup callbacks here
	edit.setAttr = function (name,value)
	{
		switch (name)
		{
			case "text":
				this.setText(value);
				break;
			default:
				alert("Unknown attribute " + name + "for button widget");
				break;
		}
	}

}


function alteratorRegisterHbox(id,parent)
{
	var hbox = alteratorRegisterWidget(id,parent,new QxHorizontalBoxLayout);
	//also setup callbacks here
}

//processing "new" action request
function alteratorNewRequest(cmd)
{
	var parent = cmd.getAttribute("parent");
	var widgetId = cmd.getAttribute("widget-id");
	var widgetType = cmd.getAttribute("type");

	switch(widgetType)
	{
		case "hbox":
			      alteratorRegisterHbox(widgetId,parent);
			      break;
		case "button":
			      alteratorRegisterButton(widgetId,parent);
			      break;
		case "edit":
			      alteratorRegisterEdit(widgetId,parent);
			      break;
		default:
			      alert("Unknown widget type "+widgetType);
			      break;
	}
}

//processing "set" action request
function alteratorSetRequest(cmd)
{
	var widgetId = cmd.getAttribute("widget-id");
	var name = cmd.getAttribute("attr");
	var value = cmd.getAttribute("value");
	
	elements[widgetId].setAttr(name,value);
}

//ask authors about a HACKS (also unused var i in load function)
function alteratorSrvRequest()
{
	var http = new  QxXmlHttpLoader();

	var values = {};
	
	values["attr1"]="value1";
	values["attr2"]="value2";
	values.length = 2; //hack for strange code in load
	function processAnswer()
	{
		var answer = http.req.responseXML; //I don't know right way to access loaded XML
		var commands = answer.getElementsByTagName("command");
		var len = commands.length;
	
	      	for(var i=0;i<len;++i)
		{
		     var elt = commands.item(i);
		     var action = elt.getAttribute("action");
		     switch (action)
		     {
		     	case "new":
				alteratorNewRequest(elt);
				break;
			case "set":
				alteratorSetRequest(elt);
				break;
			default:
				alert("Unknown action was received:"+action);
				break;
		     }
		}
		
		delete http;
	}
	
	http.addEventListener("complete",processAnswer);
	http.load("http://localhost/cgi-bin/alterator.scm",values);
}


function alteratorInit(app)
{
    elements["root"]=app.getClientWindow().getDocument();
    alteratorSrvRequest();
}
